/*! 
    \file proto_singleton.h
    \brief Definition of the proto class template, used quickly start work
    
    a simple file to copy and create a singleton-class from
*/

#ifndef _PROTO_SINGLETON_H
#define _PROTO_SINGLETON_H

#include "base_object.h"

// FORWARD DEFINITION \\

//! A default singleton class.
class ProtoSingleton : public BaseObject {

 public:
  static ProtoSingleton* getInstance(void);
  virtual ~ProtoSingleton(void);

 private:
  ProtoSingleton(void);
  static ProtoSingleton* singletonRef;
};

#endif /* _PROTO_SINGLETON_H */
